/* analyze_gtk_inheritance.pike
 *
 * Pipe grep parent_class gtk/*.h into this program;
 */

object re = Regexp("^.*gtk(.*)\.h:.*Gtk(.*)Class.*$");

class gtk_class
{
  string name;
  object parent;
  array children = ({ });;

  void create(string s)
  {
    name = s;
  }

  void add_child(object c)
  {
    children += ({ c });
  }

  void output(string level)
  {
    if (!level)
      level = "";
    write(sprintf("%s%s\n", level, name));
    children->output(level + "  ");
  }
}

mapping classes = ([ ]);

mapping lookup_class(string s)
{
  s = lower_case(s);
  return classes[s] || (classes[s] = gtk_class(s));
}

int main()
{
  foreach(Array.map(Stdio.stdin->read(0x7fffffff)/"\n", re->split) - ({ 0 }),
	  array a)
    {
      a = Array.map(a, lookup_class);
      a[0]->parent = a[1];
      a[1]->add_child(a[0]);
    }

  object root = values(classes)[0];
  while(root->parent)
    root = root->parent;

  root->output();
  return 0;
}

  
  
