/* pxlogo.pike
 *
 */

array coords = ({
  ({ 0.0, 0.0 }),
  ({ 0.7, 0.3 }),
  ({ 1.0, 1.0 }),
  ({ 0.4, 0.7 }) });

int width, height;
int fg, bg;

object window, gc;

void draw()
{
  gc->ChangeGC( (["Foreground" : bg]) );
  window->FillRectangles(gc, Types.Rectangle(0, 0, width, height));
  gc->ChangeGC( (["Foreground" : fg]) );  
  window->FillPoly(gc, 2, 0,
		   Array.map(coords, lambda(array p)
			     { return
				 Types.Point((int) (p[0] * width),
					     (int) (p[1] * height) ); }) );
}

void exposed(mixed event)
{
  if (!(event->count))
    draw();
}

void resized(mixed event)
{
//  if ( (width != width) || (event->height != height))
    {
      werror("Resized.\n");
      width = event->width;
      height = event->height;
      draw();
    }
}

void key(mixed event)
{
  if(event->data) werror(event->data);
}

void connected(object display, int success, string|void msg)
{
  if (!success)
    {
      werror(sprintf("pxlogo: connection failed, %s\n",
		     msg || "Server closed the connection"));
      exit(1);
    }
  werror("Connected!\n");  
  object root = display->DefaultRootWindow();
  fg = root->blackPixel;
  bg = root->whitePixel;
  width = root->pixWidth / 5;
  height = root->pixHeight / 5;
  
  window = root->CreateWindow(0, 0, width, height, 0);
  werror("Created a window.\n");
  gc = window->CreateGC();
  
  window->set_event_callback("ConfigureNotify", resized);
  window->set_event_callback("Expose", exposed);
  window->set_event_callback("KeyPress", key);
  window->set_event_callback("DestroyNotify", lambda() { exit(0); });
  
  window->SelectInput("StructureNotify", "Exposure", "KeyPress","KeyRelease");
  window->Map();
}

int main(int argc, array(string) argv)
{
  object dpy = Xlib.Display();
  dpy->close_handler = lambda() { exit(0); };
  dpy->io_error_handler = lambda() {exit(1); };
  werror("Attempting open...\n");
  dpy->connect_handler = connected;
  return dpy->open() ? -17 : 17;
}
