/* snoop_raw.pike
 *
 */

class buffer
{
  object to;
  object from;
  string label;

  string buffer;

  void write_callback()
    {
      // werror("write callback\n");
      int written = to->write(buffer);
      if (written <= 0)
	{
	  werror("write failed!\n");
	  return;
	}
      buffer = buffer[written..];
      if (!strlen(buffer))
	to->set_write_callback(0);
    }

  void send(string s)
    {
      buffer += s;
      if (strlen(buffer))
	to->set_write_callback(write_callback);
    }

  void read_callback(mixed id, string data)
    {
      write(sprintf("%s'%s'\n", label, data));
      send(data);
    }
  
  void create(object t, object f, string l)
    {
      to = t;
      from = f;
      label = l;
      buffer = "";
      from->set_read_callback(read_callback);
    }
}

class killer
{
  array(object) files;

  void create(object ...args)
    {
      files = args;
    }

  void kill()
    {
      files->close();
    }
}

int conn = 0;
object port;

void accept_callback()
{
  object client = port->accept();
  if (!client)
    return;
  object server = Stdio.File();
  if (!server->connect("localhost", 6003))
    return;
  ++conn;
  function die = killer(client, server)->kill;
  
  client->set_nonblocking(0,0,die);
  server->set_nonblocking(0,0,die);
  
  buffer(server, client, sprintf("%d >>", conn));
  buffer(client, server, sprintf("%d <<", conn));
}

int main()
{
  port = Stdio.Port();
  if (!port->bind(6017, accept_callback))
    return 17;
  return -17;
}

  
  
