/* test.pike
 *
 */

#define SIZE 200

int width, height;
object window;
object gc;

void structure_callback(mixed event)
{
  werror(sprintf("structure: %O\n", event));
}

void expose_callback(mixed event)
{
  werror(sprintf("expose: %O\n", event));
  window->FillRectangles(gc, Types.Rectangle(SIZE/3, SIZE/3, SIZE/3, SIZE/3));
}

void connected(object dpy)
{
  werror("Connected!\n");
  object root = dpy->DefaultRootWindow();
  int black = root->blackPixel;
  int white = root->whitePixel;
  window = root->CreateSimpleWindow(0, 0, width, height, 0, 0, white);
  werror("Created a window.\n");
  gc = window->CreateGC( ([ "Foreground" : black ]));
  
  window->set_event_callback("MapNotify", structure_callback);
  window->set_event_callback("ConfigureNotify", structure_callback);
  window->set_event_callback("Expose", expose_callback);
  window->SelectInput("StructureNotify", "Exposure", "ButtonPress", "ButtonRelease");
  window->Map();
}

int main(int argc, array(string) argv)
{
  width = height = SIZE;
  
  object dpy = Xlib.Display();
  dpy->close_handler = lambda() { exit(0); };
  dpy->io_error_handler = lambda() {exit(1); };
  werror("Attempting open...\n");
  dpy->connect_handler = connected;
  return dpy->open() ? -17 : 17;
}
